/* Initial beliefs and rules */
my_group(easss_team).
my_ssch(easss_team).

ngreetings(0).

/* Initial goals */
!setup.

// Initialisation Plans
 
+!setup : true
	<- 	.my_name(Me);
        .print("Hello from ",Me);
		.concat("group_console_",Me,GCN);
		// Creation of GroupConsole Artifact
		makeArtifact(GCN,"tools.GroupConsole",[Me],GCId);
		focus(GCId)[wsp("main")];
		.concat("scheme_console_",Me,SCN);
		makeArtifact(SCN,"tools.SchemeConsole",[Me],SCId);
		focus(SCId)[wsp("main")];
		joinRemoteWorkspace("server","localhost",_);
		joinRemoteWorkspace("easss_org","localhost",_);
		println("ready");	
		.
		
-!setup 
	<- 	.wait(1000);
		.println("Problem in Setup");
		!setup.
	
// Agent's organizational skills


// Reactive plans for events generated by the group management console (decisions of my user)
+cmd("adoptRole",Group,Role)
	<- 	.println("Going to adopt ",Role," in ",Group);
		lookupArtifact(Group,GroupId)[wsp("easss_org")];
		adoptRole(Role)[artifact_id(GroupId)];
		.println("Role adopted").

-cmd("adoptRole",Group,Role)
	<- 	.println("Going to adopt ",Role," in ",Group);
		lookupArtifact(Group,GroupId)[wsp("easss_org")];
		adoptRole(Role)[artifact_id(GroupId)];
		.println("Role adopted").
				
+cmd("leaveRole",Group,Role)
	<- 	.println("Going to leave ",Role," in ",Group);
		lookupArtifact(Group,GroupId)[wsp("easss_org")];
		leaveRole(Role)[artifact_id(GroupId)];
		.println("Role left").
		
+cmd("addScheme",Group,Scheme) 
	<- 	.println("Going to add scheme ",Scheme," in ",Group);
		lookupArtifact(Group,GroupId)[wsp("easss_org")];
      	addScheme(Scheme)[artifact_id(GroupId)];
      	.println("Scheme added").

+cmd("removeScheme",Group,Scheme)
	<- 	.println("Going to remove scheme ",Scheme," from ",Group);
		lookupArtifact(Group,GroupId)[wsp("easss_org")];
		removeScheme(Scheme)[artifact_id(GroupId)];
		.println("Scheme removed").

// Reactive plans for events generated by the scheme management console (decisions of my user)
+cmd("commitMission",Scheme,Mission)
	<- 	.println("Going to commit ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId)[wsp("easss_org")];
		commitMission(Mission)[artifact_id(SchemeId)];
		.println("Committed to mission").

+cmd("leaveMission",Scheme,Mission)
	<- 	.println("Going to leave ",Mission," in ",Scheme);
		lookupArtifact(Scheme,SchemeId)[wsp("easss_org")];
		leaveMission(Mission)[artifact_id(SchemeId)];
		.println("Mission left.").

+cmd("goalAchieved",Scheme,Goal)
	<- 	.println("Goal ", Goal, " has been achieved in ",Scheme);
		lookupArtifact(Scheme,SchemeId)[wsp("easss_org")];
      	goalAchieved(Goal)[artifact_id(SchemeId)];
      	.println("Goal achieved").


{ include("inc/skills.asl") }

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization
//{ include("$jacamoJar/templates/org-obedient.asl") }
